Package jcifs.smb

# Class SmbNamedPipe

java.lang.Object
java.net.URLConnection
jcifs.smb.SmbFile
jcifs.smb.SmbNamedPipe

public class SmbNamedPipe extends SmbFile
This class will allow a Java program to read and write data to Named Pipes and Transact NamedPipes.

There are three Win32 function calls provided by the Windows SDK that are important in the context of using jCIFS. They are:

- `CallNamedPipe` A message-type pipe call that opens, writes to, reads from, and closes the pipe in a single operation.
- `TransactNamedPipe` A message-type pipe call that writes to and reads from an existing pipe descriptor in one operation.
- `CreateFile`, `ReadFile`, `WriteFile`, and `CloseFile` A byte-type pipe can be opened, written to, read from and closed using the standard Win32 file operations.

The jCIFS API maps all of these operations into the standard Java `XxxputStream` interface. A special `PIPE_TYPE` flags is necessary to distinguish which type of Named Pipe behavior is desired.

`SmbNamedPipe` Constructor Examples
Code Sample | Description

     new SmbNamedPipe( "smb://server/IPC$/PIPE/foo",
             SmbNamedPipe.PIPE_TYPE_RDWR |
             SmbNamedPipe.PIPE_TYPE_CALL );

Open the Named Pipe foo for reading and writing. The pipe will behave like the `CallNamedPipe` interface.

     new SmbNamedPipe( "smb://server/IPC$/foo",
             SmbNamedPipe.PIPE_TYPE_RDWR |
             SmbNamedPipe.PIPE_TYPE_TRANSACT );

Open the Named Pipe foo for reading and writing. The pipe will behave like the `TransactNamedPipe` interface.

     new SmbNamedPipe( "smb://server/IPC$/foo",
             SmbNamedPipe.PIPE_TYPE_RDWR );

Open the Named Pipe foo for reading and writing. The pipe will behave as though the `CreateFile`, `ReadFile`, `WriteFile`, and `CloseFile` interface was being used.

See Using jCIFS to Connect to Win32 Named Pipes for a detailed description of how to use jCIFS with Win32 Named Pipe server processes.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`CAP_DFS`
`static final int`
`CAP_EXTENDED_SECURITY`
`static final int`
`CAP_LARGE_FILES`
`static final int`
`CAP_LEVEL_II_OPLOCKS`
`static final int`
`CAP_LOCK_AND_READ`
`static final int`
`CAP_MPX_MODE`
`static final int`
`CAP_NONE`
`static final int`
`CAP_NT_FIND`
`static final int`
`CAP_NT_SMBS`
`static final int`
`CAP_RAW_MODE`
`static final int`
`CAP_RPC_REMOTE_APIS`
`static final int`
`CAP_STATUS32`
`static final int`
`CAP_UNICODE`
`static final int`
`CAPABILITIES`
`static final int`
`CMD_OFFSET`
`static final int`
`CONN_TIMEOUT`
`static final LinkedList`
`CONNECTIONS`
`static final int`
`DEFAULT_CAPABILITIES`
`static final int`
`DEFAULT_CONN_TIMEOUT`
`static final int`
`DEFAULT_FLAGS2`
`static final int`
`DEFAULT_MAX_MPX_COUNT`
`static final int`
`DEFAULT_PORT`
`static final int`
`DEFAULT_RCV_BUF_SIZE`
`static final int`
`DEFAULT_RESPONSE_TIMEOUT`
`static final int`
`DEFAULT_SND_BUF_SIZE`
`static final int`
`DEFAULT_SO_TIMEOUT`
`static final int`
`DEFAULT_SSN_LIMIT`
`static final int`
`DELETE`
`static final int`
`ERROR_CODE_OFFSET`
`static final int`
`FILE_APPEND_DATA`
`static final int`
`FILE_DELETE`
`static final int`
`FILE_EXECUTE`
`static final int`
`FILE_READ_ATTRIBUTES`
`static final int`
`FILE_READ_DATA`
`static final int`
`FILE_READ_EA`
`static final int`
`FILE_WRITE_ATTRIBUTES`
`static final int`
`FILE_WRITE_DATA`
`static final int`
`FILE_WRITE_EA`
`static final int`
`FLAGS_COPY_SOURCE_MODE_ASCII`
`static final int`
`FLAGS_COPY_TARGET_MODE_ASCII`
`static final int`
`FLAGS_LOCK_AND_READ_WRITE_AND_UNLOCK`
`static final int`
`FLAGS_NONE`
`static final int`
`FLAGS_NOTIFY_OF_MODIFY_ACTION`
`static final int`
`FLAGS_OFFSET`
`static final int`
`FLAGS_OPLOCK_REQUESTED_OR_GRANTED`
`static final int`
`FLAGS_PATH_NAMES_CANONICALIZED`
`static final int`
`FLAGS_PATH_NAMES_CASELESS`
`static final int`
`FLAGS_RECEIVE_BUFFER_POSTED`
`static final int`
`FLAGS_RESPONSE`
`static final int`
`FLAGS_TARGET_MUST_BE_DIRECTORY`
`static final int`
`FLAGS_TARGET_MUST_BE_FILE`
`static final int`
`FLAGS_TREE_COPY`
`static final int`
`FLAGS_VERIFY_ALL_WRITES`
`static final int`
`FLAGS2`
`static final int`
`FLAGS2_EXTENDED_ATTRIBUTES`
`static final int`
`FLAGS2_EXTENDED_SECURITY_NEGOTIATION`
`static final int`
`FLAGS2_LONG_FILENAMES`
`static final int`
`FLAGS2_NONE`
`static final int`
`FLAGS2_PERMIT_READ_IF_EXECUTE_PERM`
`static final int`
`FLAGS2_RESOLVE_PATHS_IN_DFS`
`static final int`
`FLAGS2_SECURITY_SIGNATURES`
`static final int`
`FLAGS2_STATUS32`
`static final int`
`FLAGS2_UNICODE`
`static final boolean`
`FORCE_UNICODE`
`static final int`
`GENERIC_ALL`
`static final int`
`GENERIC_EXECUTE`
`static final int`
`GENERIC_READ`
`static final int`
`GENERIC_WRITE`
`static final int`
`HEADER_LENGTH`
`static final InetAddress`
`LADDR`
`static final int`
`LM_COMPATIBILITY`
`static final int`
`LPORT`
`static final int`
`MAX_MPX_COUNT`
`static final long`
`MILLISECONDS_BETWEEN_1970_AND_1601`
`static final String`
`NATIVE_LANMAN`
`static final String`
`NATIVE_OS`
`static final String`
`NETBIOS_HOSTNAME`
`static final jcifs.smb.SmbTransport`
`NULL_TRANSPORT`
`static final String`
`OEM_ENCODING`
`static final int`
`OPEN_FUNCTION_FAIL_IF_EXISTS`
`static final int`
`OPEN_FUNCTION_OVERWRITE_IF_EXISTS`
`static final int`
`PID`
`static final int`
`PIPE_TYPE_CALL`
Pipe operations should behave like the `CallNamedPipe` Win32 Named Pipe function.
`static final int`
`PIPE_TYPE_DCE_TRANSACT`
`static final int`
`PIPE_TYPE_RDONLY`
The pipe should be opened read-only.
`static final int`
`PIPE_TYPE_RDWR`
The pipe should be opened for both reading and writing.
`static final int`
`PIPE_TYPE_TRANSACT`
Pipe operations should behave like the `TransactNamedPipe` Win32 Named Pipe function.
`static final int`
`PIPE_TYPE_WRONLY`
The pipe should be opened only for writing.
`static final int`
`RCV_BUF_SIZE`
`static final int`
`READ_CONTROL`
`static final int`
`RESPONSE_TIMEOUT`
`static final int`
`SECURITY_SHARE`
`static final int`
`SECURITY_USER`
`static final int`
`SIGNATURE_OFFSET`
`static final boolean`
`SIGNPREF`
`static final int`
`SND_BUF_SIZE`
`static final int`
`SO_TIMEOUT`
`static final int`
`SSN_LIMIT`
`static final int`
`SYNCHRONIZE`
`static final boolean`
`TCP_NODELAY`
`static final int`
`TID_OFFSET`
`static final TimeZone`
`TZ`
`static final String`
`UNI_ENCODING`
`static final boolean`
`USE_BATCHING`
`static final boolean`
`USE_EXTSEC`
`static final boolean`
`USE_NTSMBS`
`static final boolean`
`USE_NTSTATUS`
`static final boolean`
`USE_UNICODE`
`static final int`
`VC_NUMBER`
`static final int`
`WRITE_DAC`
`static final int`
`WRITE_OWNER`

### Fields inherited from class jcifs.smb.SmbFile

`ATTR_ARCHIVE, ATTR_DIRECTORY, ATTR_HIDDEN, ATTR_READONLY, ATTR_SYSTEM, ATTR_VOLUME, dfs, FILE_NO_SHARE, FILE_SHARE_DELETE, FILE_SHARE_READ, FILE_SHARE_WRITE, TYPE_COMM, TYPE_FILESYSTEM, TYPE_NAMED_PIPE, TYPE_PRINTER, TYPE_SERVER, TYPE_SHARE, TYPE_WORKGROUP`

### Fields inherited from class java.net.URLConnection

`allowUserInteraction, connected, doInput, doOutput, ifModifiedSince, url, useCaches`

## Constructor Summary

Constructors
Constructor
Description
`SmbNamedPipe(String url, int pipeType)`
Open the Named Pipe resource specified by the url parameter.
`SmbNamedPipe(String url, int pipeType, NtlmPasswordAuthentication auth)`
`SmbNamedPipe(URL url, int pipeType, NtlmPasswordAuthentication auth)`

## Method Summary

Modifier and Type
Method
Description
`InputStream`
`getNamedPipeInputStream()`
Return the `InputStream` used to read information from this pipe instance.
`OutputStream`
`getNamedPipeOutputStream()`
Return the `OutputStream` used to write information to this pipe instance.

### Methods inherited from class jcifs.smb.SmbFile

`canRead, canWrite, connect, copyTo, createNewFile, createTime, delete, equals, exists, getAttributes, getCanonicalPath, getContentLength, getDate, getDfsPath, getDiskFreeSpace, getInputStream, getLastModified, getName, getOutputStream, getParent, getPath, getPrincipal, getSecurity, getSecurity, getServer, getShare, getShareSecurity, getType, getUncPath, hashCode, isDirectory, isFile, isHidden, lastModified, length, list, list, listFiles, listFiles, listFiles, listFiles, mkdir, mkdirs, pathNamesPossiblyEqual, renameTo, setAttributes, setCreateTime, setLastModified, setReadOnly, setReadWrite, toString, toURL`

### Methods inherited from class java.net.URLConnection

`addRequestProperty, getAllowUserInteraction, getConnectTimeout, getContent, getContent, getContentEncoding, getContentLengthLong, getContentType, getDefaultAllowUserInteraction, getDefaultRequestProperty, getDefaultUseCaches, getDefaultUseCaches, getDoInput, getDoOutput, getExpiration, getFileNameMap, getHeaderField, getHeaderField, getHeaderFieldDate, getHeaderFieldInt, getHeaderFieldKey, getHeaderFieldLong, getHeaderFields, getIfModifiedSince, getPermission, getReadTimeout, getRequestProperties, getRequestProperty, getURL, getUseCaches, guessContentTypeFromName, guessContentTypeFromStream, setAllowUserInteraction, setConnectTimeout, setContentHandlerFactory, setDefaultAllowUserInteraction, setDefaultRequestProperty, setDefaultUseCaches, setDefaultUseCaches, setDoInput, setDoOutput, setFileNameMap, setIfModifiedSince, setReadTimeout, setRequestProperty, setUseCaches`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### PIPE_TYPE_RDONLY

public static final int PIPE_TYPE_RDONLY
The pipe should be opened read-only.

See Also:
  - Constant Field Values

### PIPE_TYPE_WRONLY

public static final int PIPE_TYPE_WRONLY
The pipe should be opened only for writing.

See Also:
  - Constant Field Values

### PIPE_TYPE_RDWR

public static final int PIPE_TYPE_RDWR
The pipe should be opened for both reading and writing.

See Also:
  - Constant Field Values

### PIPE_TYPE_CALL

public static final int PIPE_TYPE_CALL
Pipe operations should behave like the `CallNamedPipe` Win32 Named Pipe function.

See Also:
  - Constant Field Values

### PIPE_TYPE_TRANSACT

public static final int PIPE_TYPE_TRANSACT
Pipe operations should behave like the `TransactNamedPipe` Win32 Named Pipe function.

See Also:
  - Constant Field Values

### PIPE_TYPE_DCE_TRANSACT

public static final int PIPE_TYPE_DCE_TRANSACT

See Also:
  - Constant Field Values

### DEFAULT_PORT

static final int DEFAULT_PORT

See Also:
  - Constant Field Values

### DEFAULT_MAX_MPX_COUNT

static final int DEFAULT_MAX_MPX_COUNT

See Also:
  - Constant Field Values

### DEFAULT_RESPONSE_TIMEOUT

static final int DEFAULT_RESPONSE_TIMEOUT

See Also:
  - Constant Field Values

### DEFAULT_SO_TIMEOUT

static final int DEFAULT_SO_TIMEOUT

See Also:
  - Constant Field Values

### DEFAULT_RCV_BUF_SIZE

static final int DEFAULT_RCV_BUF_SIZE

See Also:
  - Constant Field Values

### DEFAULT_SND_BUF_SIZE

static final int DEFAULT_SND_BUF_SIZE

See Also:
  - Constant Field Values

### DEFAULT_SSN_LIMIT

static final int DEFAULT_SSN_LIMIT

See Also:
  - Constant Field Values

### DEFAULT_CONN_TIMEOUT

static final int DEFAULT_CONN_TIMEOUT

See Also:
  - Constant Field Values

### LADDR

static final InetAddress LADDR

### LPORT

static final int LPORT

### MAX_MPX_COUNT

static final int MAX_MPX_COUNT

### SND_BUF_SIZE

static final int SND_BUF_SIZE

### RCV_BUF_SIZE

static final int RCV_BUF_SIZE

### USE_UNICODE

static final boolean USE_UNICODE

### FORCE_UNICODE

static final boolean FORCE_UNICODE

### USE_NTSTATUS

static final boolean USE_NTSTATUS

### SIGNPREF

static final boolean SIGNPREF

### USE_NTSMBS

static final boolean USE_NTSMBS

### USE_EXTSEC

static final boolean USE_EXTSEC

### NETBIOS_HOSTNAME

static final String NETBIOS_HOSTNAME

### LM_COMPATIBILITY

static final int LM_COMPATIBILITY

### FLAGS_NONE

static final int FLAGS_NONE

See Also:
  - Constant Field Values

### FLAGS_LOCK_AND_READ_WRITE_AND_UNLOCK

static final int FLAGS_LOCK_AND_READ_WRITE_AND_UNLOCK

See Also:
  - Constant Field Values

### FLAGS_RECEIVE_BUFFER_POSTED

static final int FLAGS_RECEIVE_BUFFER_POSTED

See Also:
  - Constant Field Values

### FLAGS_PATH_NAMES_CASELESS

static final int FLAGS_PATH_NAMES_CASELESS

See Also:
  - Constant Field Values

### FLAGS_PATH_NAMES_CANONICALIZED

static final int FLAGS_PATH_NAMES_CANONICALIZED

See Also:
  - Constant Field Values

### FLAGS_OPLOCK_REQUESTED_OR_GRANTED

static final int FLAGS_OPLOCK_REQUESTED_OR_GRANTED

See Also:
  - Constant Field Values

### FLAGS_NOTIFY_OF_MODIFY_ACTION

static final int FLAGS_NOTIFY_OF_MODIFY_ACTION

See Also:
  - Constant Field Values

### FLAGS_RESPONSE

static final int FLAGS_RESPONSE

See Also:
  - Constant Field Values

### FLAGS2_NONE

static final int FLAGS2_NONE

See Also:
  - Constant Field Values

### FLAGS2_LONG_FILENAMES

static final int FLAGS2_LONG_FILENAMES

See Also:
  - Constant Field Values

### FLAGS2_EXTENDED_ATTRIBUTES

static final int FLAGS2_EXTENDED_ATTRIBUTES

See Also:
  - Constant Field Values

### FLAGS2_SECURITY_SIGNATURES

static final int FLAGS2_SECURITY_SIGNATURES

See Also:
  - Constant Field Values

### FLAGS2_EXTENDED_SECURITY_NEGOTIATION

static final int FLAGS2_EXTENDED_SECURITY_NEGOTIATION

See Also:
  - Constant Field Values

### FLAGS2_RESOLVE_PATHS_IN_DFS

static final int FLAGS2_RESOLVE_PATHS_IN_DFS

See Also:
  - Constant Field Values

### FLAGS2_PERMIT_READ_IF_EXECUTE_PERM

static final int FLAGS2_PERMIT_READ_IF_EXECUTE_PERM

See Also:
  - Constant Field Values

### FLAGS2_STATUS32

static final int FLAGS2_STATUS32

See Also:
  - Constant Field Values

### FLAGS2_UNICODE

static final int FLAGS2_UNICODE

See Also:
  - Constant Field Values

### CAP_NONE

static final int CAP_NONE

See Also:
  - Constant Field Values

### CAP_RAW_MODE

static final int CAP_RAW_MODE

See Also:
  - Constant Field Values

### CAP_MPX_MODE

static final int CAP_MPX_MODE

See Also:
  - Constant Field Values

### CAP_UNICODE

static final int CAP_UNICODE

See Also:
  - Constant Field Values

### CAP_LARGE_FILES

static final int CAP_LARGE_FILES

See Also:
  - Constant Field Values

### CAP_NT_SMBS

static final int CAP_NT_SMBS

See Also:
  - Constant Field Values

### CAP_RPC_REMOTE_APIS

static final int CAP_RPC_REMOTE_APIS

See Also:
  - Constant Field Values

### CAP_STATUS32

static final int CAP_STATUS32

See Also:
  - Constant Field Values

### CAP_LEVEL_II_OPLOCKS

static final int CAP_LEVEL_II_OPLOCKS

See Also:
  - Constant Field Values

### CAP_LOCK_AND_READ

static final int CAP_LOCK_AND_READ

See Also:
  - Constant Field Values

### CAP_NT_FIND

static final int CAP_NT_FIND

See Also:
  - Constant Field Values

### CAP_DFS

static final int CAP_DFS

See Also:
  - Constant Field Values

### CAP_EXTENDED_SECURITY

static final int CAP_EXTENDED_SECURITY

See Also:
  - Constant Field Values

### FILE_READ_DATA

static final int FILE_READ_DATA

See Also:
  - Constant Field Values

### FILE_WRITE_DATA

static final int FILE_WRITE_DATA

See Also:
  - Constant Field Values

### FILE_APPEND_DATA

static final int FILE_APPEND_DATA

See Also:
  - Constant Field Values

### FILE_READ_EA

static final int FILE_READ_EA

See Also:
  - Constant Field Values

### FILE_WRITE_EA

static final int FILE_WRITE_EA

See Also:
  - Constant Field Values

### FILE_EXECUTE

static final int FILE_EXECUTE

See Also:
  - Constant Field Values

### FILE_DELETE

static final int FILE_DELETE

See Also:
  - Constant Field Values

### FILE_READ_ATTRIBUTES

static final int FILE_READ_ATTRIBUTES

See Also:
  - Constant Field Values

### FILE_WRITE_ATTRIBUTES

static final int FILE_WRITE_ATTRIBUTES

See Also:
  - Constant Field Values

### DELETE

static final int DELETE

See Also:
  - Constant Field Values

### READ_CONTROL

static final int READ_CONTROL

See Also:
  - Constant Field Values

### WRITE_DAC

static final int WRITE_DAC

See Also:
  - Constant Field Values

### WRITE_OWNER

static final int WRITE_OWNER

See Also:
  - Constant Field Values

### SYNCHRONIZE

static final int SYNCHRONIZE

See Also:
  - Constant Field Values

### GENERIC_ALL

static final int GENERIC_ALL

See Also:
  - Constant Field Values

### GENERIC_EXECUTE

static final int GENERIC_EXECUTE

See Also:
  - Constant Field Values

### GENERIC_WRITE

static final int GENERIC_WRITE

See Also:
  - Constant Field Values

### GENERIC_READ

static final int GENERIC_READ

See Also:
  - Constant Field Values

### FLAGS_TARGET_MUST_BE_FILE

static final int FLAGS_TARGET_MUST_BE_FILE

See Also:
  - Constant Field Values

### FLAGS_TARGET_MUST_BE_DIRECTORY

static final int FLAGS_TARGET_MUST_BE_DIRECTORY

See Also:
  - Constant Field Values

### FLAGS_COPY_TARGET_MODE_ASCII

static final int FLAGS_COPY_TARGET_MODE_ASCII

See Also:
  - Constant Field Values

### FLAGS_COPY_SOURCE_MODE_ASCII

static final int FLAGS_COPY_SOURCE_MODE_ASCII

See Also:
  - Constant Field Values

### FLAGS_VERIFY_ALL_WRITES

static final int FLAGS_VERIFY_ALL_WRITES

See Also:
  - Constant Field Values

### FLAGS_TREE_COPY

static final int FLAGS_TREE_COPY

See Also:
  - Constant Field Values

### OPEN_FUNCTION_FAIL_IF_EXISTS

static final int OPEN_FUNCTION_FAIL_IF_EXISTS

See Also:
  - Constant Field Values

### OPEN_FUNCTION_OVERWRITE_IF_EXISTS

static final int OPEN_FUNCTION_OVERWRITE_IF_EXISTS

See Also:
  - Constant Field Values

### PID

static final int PID

### SECURITY_SHARE

static final int SECURITY_SHARE

See Also:
  - Constant Field Values

### SECURITY_USER

static final int SECURITY_USER

See Also:
  - Constant Field Values

### CMD_OFFSET

static final int CMD_OFFSET

See Also:
  - Constant Field Values

### ERROR_CODE_OFFSET

static final int ERROR_CODE_OFFSET

See Also:
  - Constant Field Values

### FLAGS_OFFSET

static final int FLAGS_OFFSET

See Also:
  - Constant Field Values

### SIGNATURE_OFFSET

static final int SIGNATURE_OFFSET

See Also:
  - Constant Field Values

### TID_OFFSET

static final int TID_OFFSET

See Also:
  - Constant Field Values

### HEADER_LENGTH

static final int HEADER_LENGTH

See Also:
  - Constant Field Values

### MILLISECONDS_BETWEEN_1970_AND_1601

static final long MILLISECONDS_BETWEEN_1970_AND_1601

See Also:
  - Constant Field Values

### TZ

static final TimeZone TZ

### USE_BATCHING

static final boolean USE_BATCHING

### OEM_ENCODING

static final String OEM_ENCODING

### UNI_ENCODING

static final String UNI_ENCODING

See Also:
  - Constant Field Values

### DEFAULT_FLAGS2

static final int DEFAULT_FLAGS2

### DEFAULT_CAPABILITIES

static final int DEFAULT_CAPABILITIES

### FLAGS2

static final int FLAGS2

### CAPABILITIES

static final int CAPABILITIES

### TCP_NODELAY

static final boolean TCP_NODELAY

### RESPONSE_TIMEOUT

static final int RESPONSE_TIMEOUT

### CONNECTIONS

static final LinkedList CONNECTIONS

### SSN_LIMIT

static final int SSN_LIMIT

### SO_TIMEOUT

static final int SO_TIMEOUT

### CONN_TIMEOUT

static final int CONN_TIMEOUT

### NATIVE_OS

static final String NATIVE_OS

### NATIVE_LANMAN

static final String NATIVE_LANMAN

### VC_NUMBER

static final int VC_NUMBER

See Also:
  - Constant Field Values

### NULL_TRANSPORT

static final jcifs.smb.SmbTransport NULL_TRANSPORT

## Constructor Details

### SmbNamedPipe

public SmbNamedPipe(String url, int pipeType) throws MalformedURLException, UnknownHostException
Open the Named Pipe resource specified by the url parameter. The pipeType parameter should be at least one of the `PIPE_TYPE` flags combined with the bitwise OR operator `|`. See the examples listed above.

Throws:
  `MalformedURLException`
  `UnknownHostException`

### SmbNamedPipe

public SmbNamedPipe(String url, int pipeType, NtlmPasswordAuthentication auth) throws MalformedURLException, UnknownHostException

Throws:
  `MalformedURLException`
  `UnknownHostException`

### SmbNamedPipe

public SmbNamedPipe(URL url, int pipeType, NtlmPasswordAuthentication auth) throws MalformedURLException, UnknownHostException

Throws:
  `MalformedURLException`
  `UnknownHostException`

## Method Details

### getNamedPipeInputStream

public InputStream getNamedPipeInputStream() throws IOException
Return the `InputStream` used to read information from this pipe instance. Presumably data would first be written to the `OutputStream` associated with this Named Pipe instance although this is not a requirement (e.g. a read-only named pipe would write data to this stream on connection). Reading from this stream may block. Therefore it may be necessary that an addition thread be used to read and write to a Named Pipe.

Throws:
  `IOException`

### getNamedPipeOutputStream

public OutputStream getNamedPipeOutputStream() throws IOException
Return the `OutputStream` used to write information to this pipe instance. The act of writing data to this stream will result in response data recieved in the `InputStream` associated with this Named Pipe instance (unless of course it does not elicite a response or the pipe is write-only).

Throws:
  `IOException`